(* ------- TIR-AILLEURS ------ *)
(* Apple II + PASCAL UCSD 1.1  *)

(* Equipe Micro7: Francois DUPIN, Jean-Francois ROLLAND, Yves HUITRIC*)

PROGRAM TIR;

USES APPLESTUFFS;

CONET J9=3 ; (* Nombre de joueurs connu de Pomme *)
      C2=39; (* Nombre 'de colonnes de l'ecran  *)
      L2=23; (* Nombre de lignes de l'ecran *)
      P1=3 ; (* Coefficient de triche *)
      E='*'; (* Pigeon d'argile *)
      F=' '; (* Blanc pour le lavage de l'ecran *)
      0='X'; (* Une des phases de mort du pigeon *)
      L='-'; (* Un morceau de coup de fusil *)
      M='>'; (* Le fusi I , attention dangereux! *)

VAR 71,T2 :INTEGER;

    U3,U4,A2,A1 : INTEGER;
    U1,U2,VALC  : INTEGER;
    I,N9,J,VALS : INTEGER;
    W,V,H,K,P,U : INTEGER;
    C9,T9,P9    : ARRAY[1..6] OF INTEGER;
    N           : ARRAY[1..6] OF STRING;
    D           : ARRAY[1..J9] OF STRING;
    R,T         : STRING;
    KEY,FINCHAR : CHAR;
    TEST,TEST2  : BOOLEAN;

FUNCTION RAND(BAS,HAUT:INTEGER):INTEGER;
VAR MX,C,D :INTEGER;

BEGIN            (* Fonction donnant une suite d'entiers pseudo-aleatoire *)
  RAND:=0;       (* regulierement distribue entre les entiers Bas et Haut *)
  C:=HAUT-BAS+1;
  MX:=(MAXINT-HAUT+BAS) DIV C+1;
  MX:=MX*(HAUT-BAS)+(MX-1);
  REPEAT
    D: =RANDOM 
   UNTIL D<=MX;
  RAND:=BAS+D MOD C 
END;



PROCEDURE VALEURS(ST:STRING);
   VAR VALS1 : STRING;
   BEGIN 
	VALS:=-1; (* Procedure retournant sous le nom de VALS la valeur *)
   WHILE VALS1<>ST DO (* de l'entier contenue dans une chaine de caracteres *)
   BEGIN 
	VALS:=VALS+1;
	STR(VALS,VALS1);
   END;
END;

PROCEDURE VALEURC(CAR:CHAR);
	VAR 13 INTEGER;
	TEST1 BOOLEAN;

BEGIN		(* Procedure retournant sous le nom de VALC la valeur *)
VALC:=0;	(* de l'entier contenue dans une variable de type *)
I3:=48;		(* CHAR. *)
 REPEAT 
 IF CHR(I3)=CAR 
   THEN BEGIN 
    VALC:=I3-48;
    TEST1:=TRUE
    END;
  I3:=I3+1;
UNTIL TEST1=TRUE;
END;

PROCEDURE VIDE_BUFFER; (* Procedure permettant de vider en parti le *) 
      VAR CH :CHAR;    (* buffer du clavier avant l'entree d'une    *)
                       (* variable. (Nom edulcore pour bug systeme) *)
BEGIN 
	WHILE KEYPRESS DO READ (KEYBOARD,CH);
END;

PROCEDURE INITIALISATION;
VAR I
1 : INTEGER;

BEGIN			(* Procedure d'initialisation du programme. *)
   T1:=TRUNC(C2/2);	(* Variable permettant la presentation du texte *)
   T2:=TRUNC(C2/4*3);	(* Variable permettant la presentation du texte *)
   U2:=L2-2;		(* Numero de la ligne ou se trouve NOM RESTE POINT *)
   U3:=L2-1;		(* Ligne ou le nom, les pigeons sont affiches *)
   U4:=L2-4;		(* Variable permettant de de-finir la difficulte *)
   A2:=4;		(* Marge gauche du champ de tir *)
   A1:=(C2-A2);		(* Marge droite du chapm de tir *)
   K:=0;		(* Explication plus loin *)
   D[1]:='BAB';		(* Nom de code de Francois DUPIN *)
   DE23:='JFR';		(* Nom de code d Jean-Francois ROLLAND *)
   DE33:='Y.H';		(* Nom de code de Yves HUITRIC (desole pour l'ecran) *)
   TEST2:=FALSE;	(* Pour corriger un bug systeme *)
 
FOR I1:=1 TO C2-2 DO 
BEGIN
	T:=CONCAT(T,L); (* Generation de tout le coup de fusil *)
END;
U:=2;	(* Option de difficulte de jeu, ne soyez pas timide    *)
U1:=1;	(* Pour eviter un bug d'execution lors du premier pigeon *)
END;

PROCEDURE NOM_JOUEUR;
	VAR J1,I2: INTEGER;
	R1	 : STRING;

BEGIN		(* Procedure permettant la saisie des noms des joueurs et *) 
 REPEAT		(* l'initialisation des coefficients de triche eh,eh *)

WRITE (CHR(12)); (* 12 est le code de FF, permet de vider l'ecran *)
 WRITE (' Combien de joueur(s) (<7) ? ');
VIDE_BUFFER;
READ (KEY); (* Demande le nombre de joueurs et teste la conformite *)
VALEURC(KEY); (* de la valeur rentre, nous sommes desole pour les  *)
N9:=VALC; (* familles tres nombreuse, il faudra faire des tournois *)
 
UNTIL (N9<7) AND (N9>0);
WRITELN;
FOR J1:=1 TO N9 DO 
BEGIN
 REPEAT 
	WRITE (' Nom du joueur  ',J1,' (>1L,<',T2-2,'L) ?');(* Le nom des *)
	VIDE_BUFFER; (* joueurs, desole pour Mr SOUPALOGNON  Y CROUTON Y *) 
	READLN (N[J1]); (* DANSONSURLEPON Y DAVIGNON mais c'est trop long *)
	UNTIL (LENGTH(N[J1])>1) AND (LENGTH(N[J1])<T2-2);
C9[J1]:=0;
FOR I2:=1 TO J9 DO 
BEGIN  (* Compare avec les noms code et met le coef *)
	IF N[J1]=D[I2] (* a 1 s'il s'agit d'un initie eh,eh*)
	THEN C9[J1]:=1;
	END;

	T9[J1]:=0; (* Le nombre total de points est mis a 0 *)
	P9[J1]:=0; (* Le nombre de points de la partie en vue est mis a 0 *)
	END;
END;
PROCEDURE FIN_JEU;
	VAR J2 INTEGER;
	KEY1 : CHAR;
	(* Procedure de fin de partie et d'angoisse devant les *)

BEGIN	(* resultats, keep cool tout le monde a commence un jour *)
 WRITE(CHR(12));
 WRITE ('NOM');
 GOTOXY(T1,0);
 WRITE ('PARTIE');	(* Ligne superieure de la presentation des resultats *)
 GOTOXY(T2,0);
 WRITELN ( 'TOTAL');
 WRITELN;
FOR J2:=1 TO N9 DO 
BEGIN
 T9[J2]:=T9[J2]+P9[J2];
 GOTOXY(0,J2*2+1);
 WRITE (N[J2]);
 GOTOXY(T1,J2*2+1);	(* Affichage pour chaque joueur du resultat de *)
 WRITE(P9[J2]:3);	(* sa brillante prestation *)
 GOTOXY(T2,J2*2+1);
 WRITE (T9[J2]:3);
 P9[J2]:=0;
END;
WRITELN;
WRITELN;
WRITE ('On continue. . (N,.) ? ');
VIDE_BUFFER;

READ (KEYBOARD,KEY1);	(* Vous n'avez pas descendu assez de pigeon? Mais *)
FINCHAR:=KEY1;		(* mefiez vous de l'amicale des pigeons dont le *)
IF FINCHAR<>'N'		(* slogan bien connu : LES PIGEONS C'EST MIGNON *)
	THEN BEGIN	(* pourrait vous etre fatale na! *)		
	WRITELN;
	WRITE ('Avec les mornes joueurs (N,.) ');
VIDE_BUFFER;
READ (KEYBOARD,KEY1);	(* C'est partie pour la deuxieme manche *)
IF KEY1='N'		(* a moins que d'autre joueurs ne *)
     THEN NOM_JOUEURS;	(* penetrent sur le terrain  *)
     END;
END;
BEGIN
  
INITIALISATION;
NOM JOUEURS;		(* La boucle principale du programme *)
REPEAT
	REPEAT 
	WRITE (CHR(12));
	WRITELN (' Difficulte (0 a ',U4-5,')');
	WRITE (' <Option> ',U,' ? ');
	VIDE BUFFER;	(* Choix de la difficulte U avec une *)
	IF (T-EST2)	(* option *)
	 THEN READ(KEYBOARD,KEY) (* Sequence destine a obliger le programme *)
	 ELSE TEST2:=TRUE;	 (* a attendre que vous repondie2 a la *)
	READ (R);		(* question pour continuer *)
	IF R<>'' 
	THEN BEGIN
	 VALEURS(R);
	 U:=VALS;
	END;
UNTIL (U>0) AND (U<U4-4); (* Teste la conformite de la reponse *)
 FOR J:=1 TO N9 DO	  (* Debut de la boucle principale, J est le *)
BEGIN			  (* numero du joueur en piste *)
 WRITE (CHR(12));
 GOTOXY(5,U1);
 WRITE (N[J]);		(* Affiche le nom du joueur et *)
 GOTOXY(5,U3);		(* attend qu'il soit pret *)
 WRITELN ('Etes-vous pret???? ');
 VIDE_BUFFER;
 READ (KEYBOARD,KEY);
 FOR W:=1 TO 5 DO WRITE(CHR(7)); (* 7 est le code de la cloche *)
 WRITE (CHR(12));
 WRITELN;
 GOTOXY(1,U2);
 WRITE ('Nom joueur ');
 GOTOXY(T1,U2);
 WRITE ('Reste');	(* Affichage de la ligne de jeu *)
 GOTOXY(T2,U2);
 WRITE ('Points');
 GOTOXY(1,U3);
 WRITE (N[J]);
 FOR P:= 10 DOWNTO 1 DO	(* Debut de la partie du joueur J, P *)
 BEGIN			(* represente le nombre de pigeons restant *)
 GOTOXY(1,U1);
 WRITE(F);	(* Efface l'ancien fusil *)
 U1:=RAND(1,U)+2;
 GOTOXY(1,U1);	(* Choix aleatoire du nouveau fusil, c'est ici *)
 WRITE(M);	(* que la dificulte intervient *)
 GOTOXY(T1,U3);
 WRITE(P:2);
 GOTOXY(T2,U3);
 WRITE (P9[J]);	(* Affichage de P9[J] qui est l score provisoire*)
 H:=RAND(A2,A1); (* Colonne de vol du pigeon *)
 V:=U4;		(* Ligne de depart du piggeon *)
 VIDE BUFFER;
 REPEAT		(* Boucle de deplacement du pigeon et de tir *)
 GOTOXY(H,V+1);
 WRITE (F);
 GOTOXY(H,V);	(* Deplacement du pigeon  *)
 WRITE (E);
  IF K<>1	(* K ne vaut pas 1 si J n'a pas tire *)
  THEN  BEGIN
	IF KEYPRESS (* KEYPRESS est vrai si une touche a ete*)
	THEN BEGIN (* enfonce c'est a dire si J a tire *)
	 K:=1;
	IF V=U1 (* Test sur l'efficacite du tir *)
	 THEN BEGIN (* Test sur les chances de J *)
	IF (C9[J]=1) OR (RAND(0,P1*100)<100) 
	THEN BEGIN
	GOTOXY(2,U1);	(* J est un initie ie C9[J]=1 ou bien J a *)
	WRITE (T);	(* de la chance ie test avec P1 reussi *)
	GOTOXY(2,U1);
	write (chr(29));
	P9[J]:=P9[J]+1;
	FOR I:=1 TO 30 DO 
	BEGIN
	GOTOXY(H,V);
	WRITE (G);	(* Mort du pigeon *)
	NOTE(10,1);
	GOTOXY(H,V);
	WRITE (E);
	GOTOXY(H,V);
	WRITE (F);	(* Effacement du pigeon mort *)
	V:=1;
	END ELSE 
	BEGIN
	GOTOXY(H,V);
	WRITE (F);	(* Le joueur n'a pas eu de chance, le pigeon *)
 	V: =V-1;	(* passe, esperons que quelqu'un mettra le *)
	GOTOXY(H,V);	(* joueur au courant la prochaine fois *)
	WRITE (E);
	TEST:=TRUE;
	END;
END;
IF (TEST) OR (V<>U1) THEN 
 BEGIN		(* Le coup de feu est inscrit *)
 GOTOXY(2,U1);	(* il ne touche pas le pigeon *)
 WRITE( T);
 GOTOXY(2,U1);	(* La ligne du coup de feu est efface*)
 WRITE (CHR(29));
 TEST:=FALSE;
 END;
 END;	(* Fin du test sur le tir *)
END;

V: =V-1;
 UNTIL V=0; (* Fin du vol du pigeon *)
 GOTOXY(H,V+1);
  WRITE (F);	(* Au cas ou le pigeon serait passe, il est efface *)
 K:=0;		(* Le tir est reinitialise pour le prochain pigeon *)
 END;		(* Fin de la partie du joueur J *)
END;		(* Fin de la partie pour tous les joueurs *)
 
FIN_JEU;
 UNTIL FINCHAR='N';
END. (* Au revoir et A bientot  *)
